<template>
  <div class="outer-container mt-5 height" ref="container" v-if="isPlaying">
    <div
      class="block"
      @click="boxClicked"
      :style="{
        left: marginLeft + 'px',
        top: marginTop + 'px',
        backgroundColor: '#' + Math.floor(Math.random() * 16777215).toString(16),
        width: size + 'px',
        height: size + 'px',
        borderRadius: radius + '%',
      }"
    ></div>
  </div>
</template>

<script>
export default {
  name: 'ReactionTimer',
  props: ['isPlaying', 'stopTimer', 'size', 'radius'],
  data() {
    return {
      score: 0,
      marginLeft: 0,
      marginTop: 0,
      reactionTime: 0,
      timer: null,
    };
  },
  mounted() {
    if (!this.isPlaying) return;
    this.startTimer();
    this.marginLeft = Math.random() * (this.$refs.container.clientWidth - this.size);
    this.marginTop = Math.random() * (this.$refs.container.clientHeight - this.size);
  },
  methods: {
    boxClicked() {
      this.clearTimer();
      this.score = this.reactionTime;
      this.$emit('clicked', this.reactionTime);
    },
    startTimer() {
      this.timer = setInterval(() => {
        this.reactionTime += 10;
      }, 10);
    },
    clearTimer() {
      clearInterval(this.timer);
    },
  },
  watch: {
    stopTimer() {
      if (this.stopTimer) {
        this.clearTimer();
      }
    },
  },
};
</script>

<style scoped>
.block {
  font-size: 3rem;
  position: absolute;
}
.outer-container {
  border: none;
  position: relative;
  /* cursor: url('../assets/crosshair.png'), move; */
}
.height {
  min-height: 70vh;
}
</style>
